VERSION 5.00
Begin VB.Form dlgMain 
   Caption         =   "Beispielprojekt fr CPweScheme.cls"
   ClientHeight    =   1680
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4560
   Icon            =   "dlgMain.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   1680
   ScaleWidth      =   4560
   StartUpPosition =   3  'Windows-Standard
   Begin VB.CommandButton cmdSetThreadExecutionState 
      Caption         =   "Monitor-Standby aktiv"
      Height          =   375
      Left            =   1320
      TabIndex        =   4
      Top             =   1200
      Width           =   1935
   End
   Begin VB.CommandButton cmdWritePwrScheme 
      Caption         =   "WritePwrScheme"
      Height          =   375
      Left            =   2400
      TabIndex        =   3
      Top             =   600
      Width           =   1935
   End
   Begin VB.CommandButton cmdGetAllPwrSchemes 
      Caption         =   "GetAllPwrSchemes"
      Height          =   375
      Left            =   240
      TabIndex        =   2
      Top             =   120
      Width           =   1935
   End
   Begin VB.CommandButton cmdReadPwrScheme 
      Caption         =   "ReadPwrScheme"
      Height          =   375
      Left            =   2400
      TabIndex        =   1
      Top             =   120
      Width           =   1935
   End
   Begin VB.CommandButton cmdGetActivePwrScheme 
      Caption         =   "GetActivePwrScheme"
      Height          =   375
      Left            =   240
      TabIndex        =   0
      Top             =   600
      Width           =   1935
   End
End
Attribute VB_Name = "dlgMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Dieser Source stammt von http://www.activevb.de
'und kann frei verwendet werden. Fr eventuelle Schden
'wird nicht gehaftet.

'Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'Ansonsten viel Spa und Erfolg mit diesem Source!

'Autor: Achim Neubauer

Option Explicit

Dim MyPwrScheme As New CPwrScheme

Private Sub cmdGetAllPwrSchemes_Click()
  On Error GoTo Fehler
  
  Dim T As Long
  Dim ID As Long
  Dim Message As String
    
  With MyPwrScheme
    Message = "Anzahl der Schemen: " & CStr(.IDs.Count) & vbCrLf & _
              String$(20, "-")

    For T = 1 To .IDs.Count
      ID = .IDs(T)
      Message = Message & vbCrLf & _
                "Schema # " & CStr(T) & vbCrLf & _
                "  ID: " & ID & vbCrLf & _
                "  Name: " & .Name(ID) & vbCrLf & _
                "  Beschreibung: " & .Description(ID) & vbCrLf & _
                String$(20, "-")
    Next T
    
    MsgBox Message, , "GetAllPwrSchemes"
  End With
  
  Exit Sub
Fehler:
    MsgBox Err.Description, , Err.Source
End Sub

Private Sub cmdGetActivePwrScheme_Click()
  On Error GoTo Fehler
  
  Dim ID As Long
  
  With MyPwrScheme
    ID = .ActiveID
    
    MsgBox "Aktives Schema: ID=" & CStr(ID)
  End With
  
  Exit Sub
Fehler:
    MsgBox Err.Description, , Err.Source
End Sub

Private Sub cmdReadPwrScheme_Click()
  On Error GoTo Fehler
  
  Dim ID As Long
  Dim PP As POWER_POLICY
  
  With MyPwrScheme
    ID = .ActiveID
    PP = .Scheme(ID)
    
    MsgBox "Timeout fr Monitor-Standy (in Sekunden): " & CStr(PP.user.VideoTimeoutAc), , "ReadPwrScheme"
  End With
  
  Exit Sub
Fehler:
    MsgBox Err.Description, , Err.Source
End Sub

Private Sub cmdWritePwrScheme_Click()
  On Error GoTo Fehler

  Dim ID As Long
  Dim PP As POWER_POLICY
  Dim InputData As String
  
  With MyPwrScheme
    ID = .ActiveID
    PP = .Scheme(ID)
    
    Do
      InputData = InputBox("Neuer Timeout-Wert fr Monitor-Standby:", "WritePwrScheme", CStr(PP.user.VideoTimeoutAc), (Screen.Width - 371 * Screen.TwipsPerPixelX) / 2, (Screen.Height - 145 * Screen.TwipsPerPixelY) / 2)
      If StrPtr(InputData) = 0 Then Exit Sub
    Loop Until Val(InputData) > 0
      
    PP.user.VideoTimeoutAc = Val(InputData)
        
    .Scheme(ID) = PP
  End With
  
  Exit Sub
Fehler:
    MsgBox Err.Description, , Err.Source
End Sub

Private Sub cmdSetThreadExecutionState_Click()
  On Error GoTo Fehler

  Const ActiveCaption As String = "Monitor-Standby aktiv"
  Const InactiveCaption As String = "Monitor-Standby pausiert"
  
  With MyPwrScheme
    .MonitorStandybyHalted = Not .MonitorStandybyHalted
  
    cmdSetThreadExecutionState.Caption = IIf(.MonitorStandybyHalted, InactiveCaption, ActiveCaption)
  End With

  Exit Sub
Fehler:
    MsgBox "#" & CStr(Err.Number) & " " & Err.Description, , Err.Source
End Sub
